<?php

namespace Abit\Webhook\Controller\Adminhtml\Hook;

use Abit\Webhook\Controller\Adminhtml\Hook;
use Magento\Backend\App\Action;
use Magento\Backend\Model\View\Result\Page;

class Edit extends Hook
{

    /**
     * @inheritDoc
     */
    public function execute()
    {
        $hookId = (int) $this->getRequest()->getParam('hook_id');

        $hookData = $this->_hookFactory->create();
        /** @var Page $resultPage */
        if ($hookId) {
            $hookData = $hookData->load($hookId);

            if (!$hookData->gethookID()) {
                $this->messageManager->addError(__('hook data no longer exits'));

                return false;
            }
        }
        $this->_coreRegistry->register('hook_data', $hookData);
        $resultPage = $this->_resultPageFactory->create();
        $title = $hookId ? __('Edit Web Hook') : __('Add Web Hook');
        $resultPage->getConfig()->getTitle()->prepend($title);

        return $resultPage;
    }

    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Abit_Webhook::add_hook');
    }
}
