<?php

namespace Abit\Webhook\Controller\Adminhtml\Hook;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;

class Index extends Action
{
    /**
     * @var PageFactory
     */
    protected $_resultPageFactory = false;

    public function __construct(
        Context $context,
        PageFactory $pageFactory
    ) {
        parent::__construct($context);
        $this->_resultPageFactory = $pageFactory;
    }

    /**
     * @inheritDoc
     */
    public function execute()
    {
        $resultPage = $this->_resultPageFactory->create();
//        $resultPage->setActiveMenu('Abit_Webhook::manage_hooks');
        $resultPage->getConfig()->getTitle()->prepend(__('Manage Hooks'));

        return $resultPage;
    }

    public function _isAllowed()
    {
        return $this->_authorization->isAllowed('Abit_Webhook::manage_hooks');
    }
}
