<?php

namespace Abit\Webhook\Controller\Adminhtml\Hook;

use Abit\Webhook\Controller\Adminhtml\Hook;

class Save extends Hook
{

    public function execute()
    {
        $data = $this->getRequest()->getPostValue();
        if (!$data) {
            $this->_redirect('abit_webhook/hook/addhook');
            return;
        }

        try {
            $HookData = $this->_hookFactory->create();
            $HookData->setData($data);

            if (isset($data['id'])) {
                $HookData->setHookId($data['id']);
            }
            $HookData->save();
            $this->messageManager->addSuccess(__('Hook data has been successfully saved.'));
        } catch (\Exception $e) {
            $this->messageManager->addError(__($e->getMessage()));
        }
        $this->_redirect('abit_webhook/hook/index');
    }

    /**
     * @return bool
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Abit_Webhook::save');
    }
}
