<?php

namespace Abit\Webhook\Controller\Adminhtml\Logs;

use Abit\Webhook\Controller\Adminhtml\HookLog;
use Magento\Backend\App\Action;
use Magento\Backend\Model\View\Result\Page;

class Edit extends HookLog
{

    /**
     * @inheritDoc
     */
    public function execute()
    {
        $logId = (int) $this->getRequest()->getParam('id');

        $hookData = $this->_hookLogFactory->create();
        /** @var Page $resultPage */
        if ($logId) {
            $hookData = $hookData->load($logId);

            if (!$hookData->getID()) {
                $this->messageManager->addError(__('hook data no longer exits'));

                return false;
            }
        }
        $this->_coreRegistry->register('hook_log_data', $hookData);
        $resultPage = $this->_resultPageFactory->create();
        $title = $logId ? __('Edit Web Hook') : __('Add Web Hook');
        $resultPage->getConfig()->getTitle()->prepend($title);

        return $resultPage;
    }

    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Abit_Webhook::add_hook');
    }
}
