<?php


namespace Abit\Webhook\Model\Config\Source;

use Magento\Framework\Option\ArrayInterface;

class HookType implements ArrayInterface
{
    const NEW_ORDER     = 'new_order';
    const NEW_PRODUCT   = 'new_product';

    /**
     * @inheritDoc
     */
    public function toOptionArray()
    {
        $options = [];
        foreach ($this->toArray() as $value => $label) {
            $options[] = [
                'value' => $value,
                'label' => $label
            ];
        }

        return $options;
    }

    public function toArray()
    {
        return [
            ''                  => __('--Please Select--'),
            self::NEW_ORDER     => 'New Order',
            self::NEW_PRODUCT   => 'New Product',
        ];
    }
}
