<?php

namespace Abit\Webhook\Model\Config\Source;

use Magento\Framework\Option\ArrayInterface;

class Schedule implements ArrayInterface
{
    const DISABLE      = '0';
    const CRON_DAILY   = 'day';
    const CRON_WEEKLY  = 'week';
    const CRON_MONTHLY = 'month';
    const CRON_MINUTE  = 'minute';


    /**
     * @inheritDoc
     */
    public function toOptionArray()
    {
        $options = [];
        foreach ($this->toArray() as $value => $label) {
            $options[] = [
                'value' => $value,
                'label' => $label
            ];
        }

        return $options;
    }

    public function toArray()
    {
        return [
            self::DISABLE  => 'Disable',
            self::CRON_MINUTE   => 'Every Minute',
            self::CRON_DAILY   => 'Daily',
            self::CRON_WEEKLY   => 'Weekly',
            self::CRON_MONTHLY   => 'Monthly',
        ];
    }
}
