<?php
/**
 * Abit_Webhook Module
 *
 * @category    Abit
 * @package     Abit_Webhook
 * @author      Binhdt
 *
 */

namespace Abit\Webhook\Model;

use Magento\Framework\Model\AbstractModel;
use Abit\Webhook\Api\Data\WebhookInterface;
use Zend\Db\Sql\Ddl\Column\Varchar;

class Hook extends AbstractModel implements WebhookInterface
{
    /**
     * Initialize resource model.
     */
    protected function _construct()
    {
        $this->_init('Abit\Webhook\Model\ResourceModel\Hook');
    }

    /**
     * Get HookID.
     *
     * @return int
     */
    public function getHookId()
    {
        return $this->getData(self::HOOK_ID);
    }

    /**
     * Set HookID.
     * @param $hook_id
     * @return Hook
     */
    public function setHookId($hook_id)
    {
        return $this->setData(self::HOOK_ID, $hook_id);
    }

    /**
     * Get Name.
     *
     * @return varchar
     */
    public function getName()
    {
        return $this->getData(self::NAME);
    }

    /**
     * Set Name.
     * @param $name
     * @return Hook
     */
    public function setName($name)
    {
        return $this->setData(self::NAME, $name);
    }

}
