<?php

namespace Abit\Webhook\Observer;

use Exception;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\HTTP\Adapter\CurlFactory;
use Magento\Framework\HTTP\Client\Curl;
use Magento\Framework\ObjectManagerInterface;
use Magento\Sales\Model\Order;
use Zend_Http_Response;

class ObserverTest implements ObserverInterface
{
    /**
     * @var ObjectManagerInterface
     */
    protected $_objectManager;
    protected $messageManager;
    /**
     * @var Order
     */
    private $_order;

    /**
     * @var CurlFactory
     */
    private $curlFactory;

    /**
     * @param ObjectManagerInterface $objectManager
     * @param Order $order
     * @param CurlFactory $curlFactory
     */
    public function __construct(
        ObjectManagerInterface $objectManager,
        Order $order,
        CurlFactory $curlFactory
    ) {
        $this->_objectManager = $objectManager;
        $this->_order = $order;
        $this->curlFactory      = $curlFactory;
    }
    /**
     * @inheritDoc
     */
    public function execute(Observer $observer)
    {
        $headersConfig = [];
//        $headersConfig[] = 'Content-Type: ' . $contentType;
        $headersConfig[] = 'Content-Type: ' . 'application/json';
        $order = $observer->getEvent()->getOrder();
//        $client = new Curl();
        $address = $order->getShippingAddress()->getData();
        $url = 'https://308917642363733ebc3b5e4e709ffd4a.m.pipedream.net';

        $curl = $this->curlFactory->create();

        $curl->write('POST', $url, '1.1', $headersConfig, json_encode($address));

        $result = ['success' => false];

        try {
            $resultCurl         = $curl->read();
            $result['response'] = $resultCurl;
            if (!empty($resultCurl)) {
                $result['status'] = Zend_Http_Response::extractCode($resultCurl);
                if (isset($result['status']) && in_array($result['status'], [200, 201])) {
                    $result['success'] = true;
                } else {
                    $result['message'] = __('Cannot connect to server. Please try again later.');
                }
            } else {
                $result['message'] = __('Cannot connect to server. Please try again later.');
            }
        } catch (Exception $e) {
            $result['message'] = $e->getMessage();
        }
        $curl->close();

        return $result;
    }
}
