<?php

namespace Abit\Webhook\Setup;

use Magento\Framework\DB\Ddl\Table;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

class UpgradeSchema implements \Magento\Framework\Setup\UpgradeSchemaInterface
{

    /**
     * @inheritDoc
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer  = $setup;
        $installer->startSetup();
        $connection = $installer->getConnection();
        if (version_compare($context->getVersion(), '1.0.2') < 0) {
            $connection->modifyColumn('abit_webhook_hook_log', 'body', ['type'=> Table::TYPE_TEXT,'size'=> '2M']);
            $connection->modifyColumn('abit_webhook_hook_log', 'response', ['type'=> Table::TYPE_TEXT,'size'=> '2M']);
            $connection->modifyColumn('abit_webhook_hook_log', 'message', ['type'=> Table::TYPE_TEXT,'size'=> 512]);
        }
        if (version_compare($context->getVersion(), '1.0.3') < 0) {
            $tableName = $installer->getTable('sales_order');

            if ($installer->getConnection()->tableColumnExists($tableName, 'sourceads') === false) {
                $installer->getConnection()
                    ->addColumn(
                        $tableName,
                        'sourceads',
                        [
                            'type' => Table::TYPE_TEXT,
                            'length' => 255,
                            'nullable' => true,
                            'comment' => 'Nguon chien dich'
                        ]
                    );
            }
            if ($installer->getConnection()->tableColumnExists($tableName, 'chiendich') === false) {
                $installer->getConnection()
                    ->addColumn(
                        $tableName,
                        'chiendich',
                        [
                            'type' => Table::TYPE_TEXT,
                            'length' => 100,
                            'nullable' => true,
                            'comment' => 'chien dich'
                        ]
                    );
            }
            if ($installer->getConnection()->tableColumnExists($tableName, 'nhomchiendich') === false) {
                $installer->getConnection()
                    ->addColumn(
                        $tableName,
                        'nhomchiendich',
                        [
                            'type' => Table::TYPE_TEXT,
                            'length' => 100,
                            'nullable' => true,
                            'comment' => 'nhom chien dich'
                        ]
                    );
            }
            if ($installer->getConnection()->tableColumnExists($tableName, 'nhanvien') === false) {
                $installer->getConnection()
                    ->addColumn(
                        $tableName,
                        'nhanvien',
                        [
                            'type' => Table::TYPE_TEXT,
                            'length' => 100,
                            'nullable' => true,
                            'comment' => 'nhan vien'
                        ]
                    );
            }
            if ($installer->getConnection()->tableColumnExists($tableName, 'chanel') === false) {
                $installer->getConnection()
                    ->addColumn(
                        $tableName,
                        'chanel',
                        [
                            'type' => Table::TYPE_TEXT,
                            'length' => 100,
                            'nullable' => true,
                            'comment' => 'channel'
                        ]
                    );
            }
        }

        $installer->endSetup();
    }
}
